﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter;
using System.ComponentModel;
using Infragistics.Windows.Editors;
using Infragistics.Windows;

namespace UnboundXamComboEditor
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
        
        private void XamComboEditor_ValueChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            CellValuePresenter cell = Utilities.GetAncestorFromType(sender as DependencyObject, typeof(CellValuePresenter), false) as CellValuePresenter;
            DataItem item = ((cell).Record as DataRecord).DataItem as DataItem;

            if (item != null)
            {
                if (cell.Field.Name.Equals("Combo1"))
                {
                    item.Combo2 = (sender as XamComboEditor).ItemsProvider.Items[0].ToString(); ;
                }
            }
        }

        private void ComboLoaded(object sender, RoutedEventArgs e)
        {
            (sender as XamComboEditor).ValueChanged += new RoutedPropertyChangedEventHandler<object>(XamComboEditor_ValueChanged);
        }
    }

    public class ViewModel
    {
        public ViewModel()
        {
            Data = new ObservableCollection<DataItem>
            {
                new DataItem { ID = 1, Combo1 = "item 1", Combo2 = "item 3" },
                new DataItem { ID = 2, Combo1 = "item 2", Combo2 = "item 3" },
                new DataItem { ID = 3, Combo1 = "item 2", Combo2 = "item 3" },
                new DataItem { ID = 4, Combo1 = "item 3", Combo2 = "item 3" },
                new DataItem { ID = 5, Combo1 = "item 1", Combo2 = "item 3" },
            };

        }

        public ObservableCollection<string> GetItems()
        {
            
            return new ObservableCollection<string>
            {
                "item 1","item 2","item 3"
            };
        }

        public ObservableCollection<DataItem> Data { get; set; }
    }

    public class DataItem : INotifyPropertyChanged
    {
        public int ID { get; set; }

        private string combo1;

        public string Combo1
        {
            get { return combo1; }
            set
            {
                combo1 = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Combo1"));
                }
            }
        }

        private string combo2;

        public string Combo2
        {
            get { return combo2; }
            set
            {
                combo2 = value; 
                
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Combo2"));
                }
            }
        }



        public event PropertyChangedEventHandler PropertyChanged;
    }

    public class ItemToTextConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value != null)
            {
                if (value.ToString().Equals("item 1"))
                    return "Custom Text for Item 1";

                if (value.ToString().Equals("item 2"))
                    return "Other Text for Item 2";

                if (value.ToString().Equals("item 3"))
                    return "Text for Item 3";
            }
            return value;    
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value != null)
            {
                if (value.ToString().Equals("item 1"))
                    return "Custom Text for Item 1";

                if (value.ToString().Equals("item 2"))
                    return "Other Text for Item 2";

                if (value.ToString().Equals("item 3"))
                    return "Text for Item 3";
            }
            return value;
        }
    }

}
